/***************************************************************************************
	JavaScript Calendar - R E Webb - Email: rew222@msn.com
	//Portions of script featured on and available at JavaScript Kit: http://www.javascriptkit.com
	//Based on the Compact Calendar design of David Seah http://davidseah.com/compact-calendar/
	// Functions
		changedate(): Moves to next or previous month or year, or current month depending on the button clicked.
		buildCal(): Renders the calander into the page.
***************************************************************************************/

var mn = ['January','February','March','April','May','June','July','August','September','October','November','December', 'January'];
var dim = [31,0,31,30,31,30,31,31,30,31,30,31];		// Stores Days In Month
var today = new Date();								// Date object to store the current date
var todaysDay = today.getDay() + 1;					// Stores the current day number 1-7
var todaysDate = today.getDate();					// Stores the current numeric date within the month
var todaysMonth = today.getUTCMonth() + 1;			// Stores the current month 1-12
var stodaysMonth = todaysMonth;						// Static Variable for Current Month
var todaysYear = today.getFullYear();				// Stores the current year
var monthNum = todaysMonth;							// Tracks the current month being displayed
var yearNum = todaysYear;							// Tracks the current year being displayed
var calendarTable = "";								// Stores Calendar Table
var eastermonth = 0;								// Stores Easter Month
var easterday = 0;									// Stores Easter Day
var hcheck = new Date();							// Date Object to Check if Date is a Holiday
var cH = "month";									// Stores css Style For Month
var cDW = "daysofweek"								// Stores css Style For Days Of Week
var cD = "days";									// Stores css Style For Days
var cFD = "99ccff";									// Stores Background Color to Highlight Cell for 1st Day of Each Month
var cFE = "99ccff";									// Stores Background Color to Highlight Month Name
var brdr = 0;										// Stores css Style For Border
var TomorrowTimer;
var lastDayRefreshed;
var cid;
var hh;

//var docstate = 1;									// Test Variable for Doc State

// Amount of time desired to perform transition (in seconds).
var timeTransition = 2;

// Declare the dock and undock event handlers.
System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClosed;
System.Gadget.onUndock = resizeGadget;
System.Gadget.onDock = resizeGadget;        

function changedate(buttonpressed) {
	if (System.Gadget.docked) {
//	if (docstate == 0) {
		if (buttonpressed == "prevyr") monthNum--;
		else if (buttonpressed == "nextyr") monthNum++;
		else if (buttonpressed == "return") { monthNum = todaysMonth; yearNum = todaysYear; }

		if (monthNum == 0) { monthNum = 12; yearNum--; }
		else if (monthNum == 13) { monthNum = 1; yearNum++ }
	} else {
		if (buttonpressed == "prevyr") yearNum--;
		else if (buttonpressed == "nextyr") yearNum++;
		else if (buttonpressed == "return") yearNum = todaysYear;
	}

	lastDayRefreshed = 0;
	today = new Date() //Refresh Time

	buildCal(monthNum, yearNum);
	return;
}

function buildCal(z, y){
	if (System.Gadget.docked) {
//	if (docstate == 0) {
		var m = (z) ? z : todayMonth;
		var pm = (m-1 <= 0 ) ? 12 : m-1;
		var tc = 42;
	}else{
		var m = 1;
		var pm = 12;
		var tc = 378;
	}

	var mc = mn[m-1];
	var oD = new Date(y, m-1, 1);

	dim[1] = (((oD.getFullYear()%100!=0) && (oD.getFullYear()%4==0)) || (oD.getFullYear()%400==0)) ? 29 : 28; // Calculate Days In Month to see if current Year is a Leap Year

	oD.od = oD.getDay() + 1;

	if (TomorrowTimer) clearTimeout(TomorrowTimer);
	
	// Set timer to redraw when we hit tomorrow
	tomorrow=new Date(todaysYear, todaysMonth-1, todaysDate+1);
//	alert( (tomorrow.getTime()-today.getTime())/3600000 + " " + cnt );
	TomorrowTimer=setTimeout("changedate('return')",tomorrow.getTime()-today.getTime());
//	TomorrowTimer=setTimeout("changedate('nextyr')",1000);
	
	if (todaysDate == lastDayRefreshed) return;
	lastDayRefreshed = todaysDate;

	easter(yearNum);

	calendarTable = '<div class="main"><table class="main" cols="9" cellpadding="1" border="'+brdr+'" cellspacing="1"><tr align="center">';

	// Add Title Row With Arrows and Displayed Year
	calendarTable += '<th colspan="5" align="left" class="'+cH+'"><a href=\"javascript:changedate(\'return\')\" class="month" style="text-decoration:none">Compact Calendar</td>';
	calendarTable += '<th align=\"center\" valign=\"center\" ><a href=\"#\" onMouseOver=\"document.PrevYr.src=\'images\/cPrev-hot.png\';\" onMouseOut=\"document.PrevYr.src=\'images\/cPrev.png\';\" onClick=\"changedate(\'prevyr\')\"><img name=\"PrevYr\" src=\"images\/cPrev.png\" border=\"0\" alt=\"Prev\"\/><\/a><\/td>';
	calendarTable += '<th align="center" valign="center" ><a href="#" onMouseOver=\"document.NextYr.src=\'images\/cNext-hot.png\';\" onMouseOut=\"document.NextYr.src=\'images\/cNext.png\';\" onClick=\"changedate(\'nextyr\')\"><img name=\"NextYr\" src=\"images\/cNext.png\" border=\"0\" alt=\"Next\"\/><\/a><\/td>';
	calendarTable += '<th colspan="2" align="right" class="'+cH+'">'+yearNum+'</td>';

	// Add Header Row For Days of Week

	calendarTable += '<tr align="right">'; 
		calendarTable += '<td class="daysofweek">Month</td><td class="daysofweek">w</td>';
		for(s = 0; s < 7; s++) calendarTable += '<td style="width:13px" class="'+cDW+'">' + "SMTWTFS".substr(s,1) + '</td>';
	calendarTable += '</tr>';

	
	// Add Calendar Days
	calendarTable += '<tr align="right">';


	// *************** Add Previous Month's Days to Table
	x = dim[pm-1] - oD.od + 2;			//Last Month's Monday
	for(q=1;q<oD.od;q++) {

		switch (System.Gadget.docked) {
//		switch ( docstate ) {
//		case 0:
		case (true):
			if (pm-1 == 11 ) var py = y-1;
			else py = y;
			weekcnt = weeknumber(py,pm-1,x+1);
			break;
//		case 1:
		case (false):
			weekcnt = weeknumber(y-1,11,x+1);
			break;
		}

		cFE=(mc!="")? "99ccff" : "";	//Highlight Month Name
	
		calendarTable += ((q)%7==1)? '<td class="months" align="left" BGCOLOR="'+cFE+'">'+mc+'</td><td class="wndays">'+weekcnt+'</td><td class="'+cD+'">'+x+'</td>' : '<td BGCOLOR="" class="'+cD+'">'+x+'</td>';
		
		x++;

		if(((q)%7 == 0)) calendarTable += '</tr><tr align="right">';
	}



	// *************** Add Current Years and Month's Days to Table
	x=1; mc = "";
	for(i=oD.od;i<=tc;i++){ 

//		if (x == 29 && m == 12){ debugger; }

		if (System.Gadget.docked) m=(m==13)?1:m;
//		if (docstate == 0) m=(m==13)?1:m;
		weekcnt = weeknumber(y,m-1,x+1);
		
		// Add Month to Variable If The 1st Is On The Current Table Row
		if (x == 1)	mc = mn[m-1];
		else if(((i)%7 == 1) && x+6-dim[m-1] > 0) mc = mn[m];

		cFD=(x==1)? "99ccff" : ""; // Highlight Cell for 1st Day of Each Month
		if((i)%7 == 0 || ((i)%7 == 1)) cD='weekenddays';else cD='days'; // Gray Font for Weekend Days

		cFE=(mc!="")? "99ccff" : "";  // Highlight Month Name
		if (m+1== stodaysMonth && y == todaysYear ) cFE=(mc!="")? "#ccff66" : "";
		x=(x<10)? "0"+x : x; // Add Leading Zero When Single Digit

		hcheck = new Date(y, m-1, x); //Date Object For Current Day
		if (i - oD.od >= 0) { if( check_holiday(hcheck) ){cD = 'holidaystyle'}; cid=hh; } // Pass Current Date Object To Check If Holiday

		if ( stodaysMonth == m &&  todaysYear == oD.getFullYear() && x == today.getDate() ){cD = 'todaystyle'; cid = "Today"; } // Highlight Todays Date
		if ( m == eastermonth && x == easterday ) {cD = 'holidaystyle'; cid = "Easter"; } // Highlight Easter
//		if ( m == 7 && x == 12 ){cD = 'birthdaystyle'; cid = "Happy Birthday"} // Highlight Authors Birthday  :)

		calendarTable += ((i)%7==1)? '<td class="months" align="left" BGCOLOR="'+cFE+'">'+mc+'</td><td class="wndays">'+weekcnt+'</td><td id="'+cid+'" BGCOLOR="'+cFD+'" class="'+cD+'" onmouseover="goHo(this)" onmouseout="goHo2(this)">'+x+'</td>' : '<td id="'+cid+'" style="background-color:'+cFD+'" class="'+cD+'" onMouseOver="goHo(this)"  onmouseout="goHo2(this)">'+x+'</td>';

		if(x<dim[m-1]){x++;} else{x=1; m++; }  // Check EOM and Start at 1
		if(((i)%7 == 0)) {calendarTable += '</tr><tr align="right">'; } // Check End Of Row

		if (m == 13) {m = 1; y++; }

		mc = ""; cid = "";

	}
//		alert(calendarTable.substr(3000,1000)); return;

	calendarTable += '</tr><tr><td colspan="6" align = "left"><p id="hu">'+cid+" "+todaysMonth+"/"+todaysDate+"/"+todaysYear+'</p></td><td colspan="4" style="font-size:6px" align="right">&copy2011 REW</td></tr></table></div>';

	var object=document.getElementById('calendar');
	object.innerHTML = calendarTable;
}

function goHo(tablecell) {
	ss = saveBackgroundStyle(tablecell);
	tablecell.className="tdHover";
	hu.innerHTML = tablecell.innerHTML+" "+tablecell.id;
}

function goHo2(tablecell) {
tablecell.className = ss.className;
}

function saveBackgroundStyle(myElement)
{
  saved=new Object();
  saved.element=myElement;
  saved.className=myElement.className;
  saved.backgroundColor=myElement.style["backgroundColor"];
  return saved; 
}

function easter(year) {
	// Feed in the year it returns the month and day of Easter using two GLOBAL variables: eastermonth and easterday
	var a = year % 19;
	var b = Math.floor(year/100);
	var c = year % 100;
	var d = Math.floor(b/4);
	var e = b % 4;
	var f = Math.floor((b+8) / 25);
	var g = Math.floor((b-f+1) / 3);
	var h = (19*a + b - d - g + 15) % 30;
	var i = Math.floor(c/4);
	var j = c % 4;
	var k = (32 + 2*e + 2*i - h - j) % 7;
	var m = Math.floor((a + 11*h + 22*k) / 451);
	var month = Math.floor((h + k - 7*m + 114) / 31);
	var day = ((h + k - 7*m +114) % 31) + 1;
	eastermonth = month;
	easterday = day;
}

function check_holiday (dt_date) {

	// check simple dates (month/date - no leading zeroes)

	var n_date = dt_date.getDate(),
		n_month = dt_date.getMonth() + 1;
	var s_date1 = n_month + '/' + n_date;

		//alert(s_date1);

	if (s_date1 == '1/1'){hh = "New Year\'s Day"; return true;}
	else if (s_date1 == '6/14') {hh = "Flag Day"; return true;}
	else if ( s_date1 == '7/4') {hh = "Independance Day"; return true;}
	else if (s_date1 == '11/11') {hh = "Veterans Day"; return true;}
	else if (s_date1 == '12/25') {hh = "Christmas Day"; return true;}

	// weekday from beginning of the month (month/num/day)

	var n_wday = dt_date.getDay(),
		n_wnum = Math.floor((n_date - 1) / 7) + 1;
	var s_date2 = n_month + '/' + n_wnum + '/' + n_wday;

	if (s_date2 == '1/3/1'){hh = "Martin Luther King\'s Birthday"; return true;}
	else if (s_date2 == '2/3/1') {hh = "Washington\'s Birthday"; return true;}
	else if ( s_date2 == '5/3/6') {hh = "Armed Forces Day"; return true;}
	else if (s_date2 == '9/1/1') {hh = "Labor Day"; return true;}
	else if (s_date2 == '10/2/1') {hh = "Columbus Day"; return true;}
	else if (s_date2 == '11/4/4') {hh = "Thanksgiving Day"; return true;}

	// weekday number from end of the month (month/num/day)

	var dt_temp = new Date (dt_date);
	dt_temp.setDate(1);
	dt_temp.setMonth(dt_temp.getMonth() + 1);
	dt_temp.setDate(dt_temp.getDate() - 1);
	n_wnum = Math.floor((dt_temp.getDate() - n_date - 1) / 7) + 1;
	var s_date3 = n_month + '/' + n_wnum + '/' + n_wday;
	
	if (   s_date3 == '5/1/1'  // Memorial Day, last Monday in May
	) {hh = "Memorial Day"; return true;}

	// Misc Complex Dates

	if (s_date1 == '1/20' && (((dt_date.getFullYear() - 1937) % 4) == 0) 
	// Inauguration Day, January 20th every four years, starting in 1937. 
	) {hh = "Inauguration Day"; return true;}
		
	if (n_month == 11 && n_date >= 2 && n_date < 9 && n_wday == 2
	// Election Day, Tuesday on or after November 2. 
	) {hh = "Election Day"; return true; }
	hh="";
	return false;
}


function settingsClosed(event) {
    if(event.closeAction == event.Action.commit) {
        loadSettings();
	}
}


/** Get the ISO Week Number */  
Date.prototype.getWeek = function () {  
  with (new Date(this.valueOf())) { var DoW = getDay()
    setDate(getDate() - (DoW+6)%7 + 3 ) // Nearest Thu
    var ms = valueOf() // GMT
    setMonth(0, 4) // Jan 4 is in Week 1
    var WN = Math.round( (ms-valueOf()) / (7*864e5) ) + 1
//    return [getFullYear(), WN, DoW==0 ? 7 : DoW] } }
//	return [getFullYear(), WN, DoW || 7] }
	return [WN] } 
}


/** Get the ISO Week Number */
function weeknumber(y,m,d) {  

//  with (new Date(this.valueOf())) { var DoW = getDay()
	with (new Date(y,m,d)) { var DoW = getDay()
    setDate(getDate() - (DoW+6)%7 + 3 ) // Nearest Thu
    var ms = valueOf() // GMT
    setMonth(0, 4) // Jan 4 is in Week 1
    var WN = Math.round( (ms-valueOf()) / (7*864e5) ) + 1
//    return [getFullYear(), WN, DoW==0 ? 7 : DoW] } }
//	return [getFullYear(), WN, DoW || 7] }
//	return WN } 
	return WN=(WN<10)? "0"+WN : WN; }
}


function resizeGadget() {
	if(System.Gadget.docked == true) {
		mainBody.style.height = 140;
		mainBody.style.width = 200;
		changedate("return");
	} else {
		mainBody.style.height = 782;
		mainBody.style.width = 200;
		changedate("return");
	}
}
